• Codeforces 451A Game With Sticks


    Description

    After winning gold and silver in IOI 2014, Akshat and Malvika want to have some fun. Now they are playing a game on a grid made of nhorizontal and m vertical sticks.

    An intersection point is any point on the grid which is formed by the intersection of one horizontal stick and one vertical stick.

    In the grid shown below, n = 3 and m = 3. There are n + m = 6 sticks in total (horizontal sticks are shown in red and vertical sticks are shown in green). There are n·m = 9 intersection points, numbered from 1 to 9.

    The rules of the game are very simple. The players move in turns. Akshat won gold, so he makes the first move. During his/her move, a player must choose any remaining intersection point and remove from the grid all sticks which pass through this point. A player will lose the game if he/she cannot make a move (i.e. there are no intersection points remaining on the grid at his/her move).

    Assume that both players play optimally. Who will win the game?

    Input

    The first line of input contains two space-separated integers, n and m (1 ≤ n, m ≤ 100).

    Output

    Print a single line containing "Akshat" or "Malvika" (without the quotes), depending on the winner of the game.

    Sample test(s)
    input
    2 2
    output
    Malvika
    input
    2 3
    output
    Malvika
    input
    3 3
    output
    Akshat
    Note

    Explanation of the first sample:

    The grid has four intersection points, numbered from 1 to 4.

    If Akshat chooses intersection point 1, then he will remove two sticks (1 - 2 and 1 - 3). The resulting grid will look like this.

    Now there is only one remaining intersection point (i.e. 4). Malvika must choose it and remove both remaining sticks. After her move the grid will be empty.

    In the empty grid, Akshat cannot make any move, hence he will lose.

    Since all 4 intersection points of the grid are equivalent, Akshat will lose no matter which one he picks.

    •题意:给你n+m根筷子,将他们分别水平、垂直放置,形成n*m个节点。两个人轮流选择一个点,将穿过这个点的两根筷子拿走,谁可以逼迫对方率先无法继续操作,谁就获胜,问获胜的是先手还是后手。
    •找规律即可。n,m中较小的那个数是奇数,先手胜,否则后手胜。
     
     1 #include<stdio.h>
     2 
     3 int main()
     4 {
     5 
     6     int n, m, a;
     7     while(scanf("%d%d", &n, &m) != EOF){
     8         if(n < m)
     9             a = n;
    10         else
    11             a = m;
    12         if(a %2 == 1)
    13             printf("Akshat
    ");
    14         else
    15             printf("Malvika
    ");
    16     }
    17     return 0;
    18 }
  • 相关阅读:
    [USACO06NOV]Corn Fields(状压DP)
    关灯问题II (状态压缩 BFS)
    天梯---至多删三个字符(DP)
    天梯
    蓝桥
    天梯
    天梯
    天梯
    天梯
    蓝桥
  • 原文地址:https://www.cnblogs.com/zzy9669/p/3871414.html
Copyright © 2020-2023  润新知